/*
**************************************************************
* Programe name: 3-3.cpp
* Author:		 Seif Azghandi
* Date written:	 02/08/2007
* Programe description:
*		This program calculates factorial of positive integer
*		numbers. If the entered number is negative, it throws
*		domain_error exception.
**************************************************************
*/

#include "3-3.h"

/*
***************
*	The driver
***************
*/
int main()
{
  int num, res;
  cout << "Please input an integer value: ";
  cin >> num;
  try
  {
      res = fact(num);
      cout << "The factorial of "<<num<<" is: " << res << endl;
  }
  catch (domain_error & e)
  {
      cerr << e.what() << endl;
  }
  return 0;
}

// Factorial calculation (function definition)

int fact(int local_var) throw(domain_error)
{
	int temp;

	if(local_var < 0)
		throw domain_error("ERROR: factorial of a negative number is not defined.");
	//Special cases: deviating from normal factorial calculation
	else
	{
		if(local_var == 0 || local_var == 1)
			temp = 1;
		else
		{
			temp = local_var;

			for(int i=1;i<local_var;i++)
			{
				temp = temp * (local_var - i);
			}
		}
	}
	return temp;
}
